/*
 * help_option.h
 *
 *  Created on: 2011-09-04
 *      Author: Wojciech Frohmberg
 *              Michal Kierzynka
 */

#ifndef HELP_OPTION_H_
#define HELP_OPTION_H_

#include <string>

#include "option.h"
#include "root_option.h"

namespace core {

    using std::string;
    using std::vector;

    class HelpOption: public Option {
    private:
        RootOption *root;
    public:
        virtual void setRootOption(RootOption *root);
        virtual vector<string> &getCommands(void);
        virtual string getDescription(void);
        virtual void executeOption(map<string, void *> &params);
    };

}

#endif /* HELP_OPTION_H_ */
